clear all
close all
clc

load data_TP
% P is given in kPa

figure;plot(max(z),P,'s','markersize',10);

Nstep=size(x,2);
Nbel=size(TRI,1);

hmesh=0.5;calcul_F;calcul_def_virt;

% figure;
% for k=1:4:size(z,2),
%     plot3(x(:,k),y(:,k),z(:,k),'.');axis equal
%     pause
% end

pause

% with neohooke model
sigma11=2*F11_tensor.*F11_tensor+2*F12_tensor.*F12_tensor-2*F33_tensor.*F33_tensor;
sigma22=2*F22_tensor.*F22_tensor+2*F21_tensor.*F21_tensor-2*F33_tensor.*F33_tensor;
sigma12=2*F21_tensor.*F11_tensor+2*F22_tensor.*F12_tensor;
Wint=(EV11_tensor.*sigma11+EV22_tensor.*sigma22+2*EV12_tensor.*sigma12).*surf_fin.*F33_tensor ;
Wint_tot=sum(Wint)./sum(surf_fin);Wext_tot=P';
C10_NeoHooke=Wext_tot/Wint_tot
R2NeoHooke = 1 - sum((C10_NeoHooke*Wint_tot-Wext_tot).^2)/sum((mean(Wext_tot)-Wext_tot).^2)
figure;plot(max(z),Wext_tot(1:end),'s','markersize',10);hold on;
plot(max(z),C10_NeoHooke*Wint_tot(1:end),'k--','linewidth',3);ylim([0,max(Wext_tot)]);

% with exponential model
I1 = F11_tensor.*F11_tensor + F22_tensor.*F22_tensor + F33_tensor.*F33_tensor ;
dW_dI1 = exp(I1-3) ; % W = C10 exp(I1-3)
sigma11=(2*F11_tensor.*F11_tensor+2*F12_tensor.*F12_tensor-2*F33_tensor.*F33_tensor).*dW_dI1;
sigma22=(2*F22_tensor.*F22_tensor+2*F21_tensor.*F21_tensor-2*F33_tensor.*F33_tensor).*dW_dI1;
sigma12=(2*F21_tensor.*F11_tensor+2*F22_tensor.*F12_tensor).*dW_dI1;
Wint=(EV11_tensor.*sigma11+EV22_tensor.*sigma22+2*EV12_tensor.*sigma12).*surf_fin.*F33_tensor ;
Wint_tot=sum(Wint)./sum(surf_fin);
C10_expo=Wext_tot/Wint_tot
R2 = 1 - sum((C10_expo*Wint_tot-Wext_tot).^2)/sum((mean(Wext_tot)-Wext_tot).^2)
plot(max(z),C10_expo*Wint_tot(1:end),'k-','linewidth',3);
xlabel('maximum deflection (mm)','fontsize',20);
ylabel('pressure (kPa)','fontsize',20);
legend({'Experimental values',['Neohooke fit, R2=' num2str(R2NeoHooke)],['Exponential fit, R2=' num2str(R2)]},'location','northwest','fontsize',16)
box off;grid on
%print(gcf,'-dpng','results.png')
% 
% Myplot(xGfin,yGfin,zGfin,sigma11(:,end))
% Myplot(xGfin,yGfin,zGfin,sigma22(:,end))
% Myplot(xGfin,yGfin,zGfin,sigma12(:,end))